{% macro modal_input_image(images = null) %}
    <a class="btn waves-light waves-effect" id="pilih_foto">Pilih Foto</a>
    <div class="images-wrapper row">
        {% if images is not null %}
            {% for image in images %}
                <div id="img_{{ image.getImage().getId() }}" class="col" style="margin-top: 20px">
                    <a class="hapus_img" style="position: absolute" onclick="deleteSelImg('{{ image.getImage().getId() }}')">
                        <i class="material-icons">close</i>
                    </a>
                    <input class="hide" name="pictures[]" value="{{ image.getImage().getId() }}">
                    <div class="gen-img-div">
                        <img class="gen-img" src="{{ image.getImage().getImagePath() }}">
                    </div>
                </div>
            {% endfor %}

        {% endif %}
    </div>

    <div class="modal modal-show modal-big" id="modal_input_img">
        <div class="modal-content" style="background-color: white">
            <div class="row" style="margin-bottom: 0">
                <h6 class="text-bold">Image Manager  <a class="btn btn-small red right modal-close" style="height: 26px; line-height: 26px; padding: 0 10px"><i
                                class="material-icons">close</i></a></h6>
                Apabila gambar <b>belum tampil / menghilang</b> setelah di upload, tekan tombol refresh <a class="btn btn-small green" style="height: 26px; line-height: 26px; padding: 0 10px" onclick="getImages()"><i class="material-icons">refresh</i></a>
                <div class="input-field col s12" style="margin-bottom: 20px; ">
                    <div style="overflow: auto; position: absolute; width: 100%; height: 300px; border: 1px solid black" id="div_img" class="row checkbox-fasilitas div_img"
                         id="checkbox-radio-icon">
                        {% for a in 0..15 %}
                            <div class="col container-img" >
                                <div class="shine" style="width:182px; height:100px; margin: 10px 0">

                                </div>
                            </div>
                        {% endfor %}
                    </div>
                </div>
                <div class="col s12 center" style="display: flex; justify-content: center">
                    <div class="file-field input-field" style="margin-top: 300px">
                        <div class="btn btn-small waves-effect waves-light" style="height: 30px; line-height: 30px;">
                            <span>Upload Gambar</span>
                            <input type="file" onchange="handleImageUpload(event);" class="small" id="img_input" multiple="multiple" accept="image/jpeg">
                        </div>

                    </div>
                </div>
                <div class="col s12">
                    <p style="margin: 0" class="text-bold">Info :</p>
                    <ol style="margin: 0" class="text-bold">
                        <li>Klik pada foto untuk menambahkan foto property</li>
                        <li>Upload gambar untuk menambahkan foto pada image manager</li>
                    </ol>
                </div>
            </div>
        </div>
    </div>
{% endmacro %}

{% macro input_image() %}
    <script type="text/javascript"
            src="https://cdn.jsdelivr.net/npm/browser-image-compression@latest/dist/browser-image-compression.js"></script>

    <script>
        $(document).on('click', 'a#pilih_foto', function () {
            $('#modal_input_img').modal('open');
            getImages();
        });

        function deleteSelImg(id) {
            $("#img_" + id).remove();
        }

        function addData(id, img) {
             $(".images-wrapper").append('<div id="img_' + id + '" class="col" style="margin-top: 20px">' +
                '<a class="hapus_img" style="position: absolute" onclick="deleteSelImg(' + "'" + id + "'" + ')"><i class="material-icons">close</i></a>' +
                '<input class="hide" name="pictures[]" value="' + id + '"/>' +
                '<div class="gen-img-div">' +
                '<img class="gen-img" src="'+img+'">' +
                '</div>' +
                // '<div class="gen-img" style=" background-image: url(' + img + ')" ></div>' +
                '</div>');
            showToast('Gambar telah ditambahkan untuk foto property', 'success');
        }

        function getImages() {
            $.ajax({
                type: "GET",
                url: "{{ path('get-filemanager') }}",
                success: function (data) {
                    console.log("LOG SUCCESS", data);
                    // var data = JSON.parse(data);
                    var html = '';

                    data.forEach(function (element) {
                        html +=
                            '<div class="col container-img " style="">' +
                            '<a class="hapus_img" onclick="remove_img(' + element['id'] + ')"><i class="material-icons center">close</i></a>' +
                            '<div onclick="addData(' + "'" + element['id'] + "','" + element['imagePath'] + "'," + ')" style="cursor:pointer; float:left;padding: 0px;  margin: 10px 0; ">' +
                            '<div class="gen-img-div">' +
                            '<img class="gen-img" src="'+element['imagePath']+'">' +
                            '</div>' +
                            // '<div class="gen-img" style="background-image: url(' + element['imagePath'] + ')"></div>' +
                            '</div>' +
                            '</div>';
                    });
                    html += '';
                    console.log(html);
                    $(".div_img").html(html);
                },
                error: function (error) {
                    console.log("LOG ERROR", error);
                    // handle error
                },
                async: true,
                cache: false,
                contentType: false,
                processData: false,
                timeout: 60000
            });
        }

        function remove_img(number) {
            $.ajax({
                type: "POST",
                url: "{{ path('delete-filemanager') }}",
                data: {
                    id: number
                },
                success: function (dataResult) {
                    getImages();
                    // your callback here
                    showToast('Gambar berhasil dihapus', 'success');
                },
                error: function (error) {
                    console.log("LOG ERROR", error);
                    // handle error
                    showToast('Gambar gagal dihapus', 'warning');
                },
                async: true,
                cache: false,
                // contentType: false,
                // processData: false,
                timeout: 60000
            });
        }

        async function handleImageUpload(event)  {
            const files = event.target.files;
            for (var i = 0; i < event.target.files.length; i++) {
                // console.log("FILE ", imageFile)
                const imageFile = event.target.files[i];
                console.log('originalFile instanceof Blob', imageFile instanceof Blob); // true
                console.log(`originalFile size ${imageFile.size / 1024 / 1024} MB`);

                const options = {
                    maxSizeMB: 0.5,
                    maxWidthOrHeight: 1000,
                    useWebWorker: true
                };
                try {
                    const compressedFile = await imageCompression(imageFile, options);// smaller than maxSizeMB

                    await uploadToServer(compressedFile).then(); // write your own logic

                } catch (error) {
                    console.log(error);
                    showToast('Gambar gagal di upload '+error, 'warning');

                }

            }

        }

        async function uploadToServer(compressedFile) {
            var formData = new FormData();

            // add assoc key values, this will be posts values
            formData.append("file", compressedFile, compressedFile.name);

            $.ajax({
                type: "POST",
                url: "{{ path('image-upload') }}",
                success: function (data) {
                    getImages();
                    showToast('Gambar berhasil di upload', 'success');
                    // your callback here
                },
                error: function (error) {
                    console.log("LOG ERROR", error);
                    // handle error
                },
                async: true,
                data: formData,
                cache: false,
                contentType: false,
                processData: false,
                timeout: 60000
            });
        }

        $(function () {
            // Multiple images preview in browser
            var imagesPreview = function (input, placeToInsertImagePreview) {

                if (input.files) {
                    var filesAmount = input.files.length;
                    for (i = 0; i < filesAmount; i++) {
                        var reader = new FileReader();
                        reader.onload = function (event) {
                            $container = $('<div class="col container-img shine " style="padding: 5px"></div>').appendTo(placeToInsertImagePreview),
                                $button = $('<a class="hapus_img" style="position: absolute; z-index: 100"><i class="material-icons center">close</i></a>').appendTo($container),
                                $check = $('<div style="height: 100px; width: 180px" class="center"><img src="' + event.target.result + '" height="100"></div>').appendTo($container);
                        };
                        reader.readAsDataURL(input.files[i]);
                    }
                }
            };

            $('#img_input').on('change', function () {
                imagesPreview(this, '.div_img');
            });
        });
    </script>
{% endmacro %}